{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 7 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit grf;
{-----------------------------------------------------------------------------}

interface
{-----------------------------------------------------------------------------}
uses dspack,activeX,directshow9,dsutil,dialogs;
{-----------------------------------------------------------------------------}
function loadGRF(fichier:widestring;fg:TFiltergraph):Boolean;
function saveGRF(fichier:widestring;fg:TFiltergraph):Boolean;
function geterrorText(hr:HResult):string;
{-----------------------------------------------------------------------------}
implementation
{--------------------------------------------------------------------------}
    function loadGRF(fichier:widestring;fg:TFiltergraph):Boolean;
    var  hr:HResult;
        pStorage:IStorage;
        pPersist:IPersiststream;
        pStream:IStream;
    begin
    result:=false;
    try
    try
    if StgIsStorageFile(pwidechar(fichier))<>S_Ok then exit;
    hr:= StgOpenStorage(pwidechar(fichier), nil, STGM_TRANSACTED or STGM_READ or 
    STGM_SHARE_DENY_WRITE,0, 0, pStorage);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
    hr:=fg.QueryInterface(IPersistStream,pPersist);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     hr:= pStorage.OpenStream('ActiveMovieGraph', 0, STGM_READ or
    STGM_SHARE_EXCLUSIVE, 0, pStream);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     hr:= pPersist.Load(pStream);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     result:=true;
    except
    end;
    finally
        pStorage:=nil;
        pStream:=nil;
        pPersist:=nil;
    end;
    end;
{--------------------------------------------------------------------------}
    function saveGRF(fichier:widestring;fg:TFiltergraph):Boolean;
    var  hr:Hresult;
        pStorage:IStorage;
        pStream:IStream;
        pPersist:IPersistStream;
    begin
    result:=false;
    try
    try
    hr:= StgCreateDocfile(pwidechar(fichier),STGM_CREATE or STGM_TRANSACTED or 
    STGM_READWRITE or STGM_SHARE_EXCLUSIVE,0, pStorage);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     hr:= pStorage.CreateStream('ActiveMovieGraph',STGM_WRITE or STGM_CREATE or
    STGM_SHARE_EXCLUSIVE,0, 0, pStream);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     fg.QueryInterface(IPersistStream,pPersist);
    hr:= pPersist.Save(pStream, TRUE);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     pStorage.Commit(STGC_DEFAULT);
    if FAILED(hr) then begin
        messagedlg(geterrortext(hr),mtError,[mbOk],0);
        exit;
    end;
     result:=true;
    except
    end;
    finally
        pStorage:=nil;
        pStream:=nil;
        pPersist:=nil;
    end;
    end;
    
{--------------------------------------------------------------------------}
function geterrortext(hr:Hresult):string;
var s:string;
    buf:array[0..255]of char;
begin
AMGetErrortextA(hr,@buf,255);
result:=buf;
end;

{-----------------------------------------------------------------------------}
end.
